Pony runtime goes out of memory under high CPU load / concurrency
This looks suspiciously like issue #494.

Running on Windows I don't see the segfault, but I do terminate (which I shouldn't) after between a few and a hundred `_on_finished` messages.

To be sure the out of memory behavior still occurs I tried to reproduce this issue again with version `0.2.1-549-gab62f55` and I still observed the same behavior.

I have also tried to reproduce the issue on several virtual machines (all Ubuntu servers with various kernels, cloud hosted) and was able to reproduce the issue when the virtual machine had more than one core. I did reuse the binary from my own machine in these tests.

Furthermore #ponylang user ponysaurus tried to reproduce the issue on Debian and OS X but did not observe the same behavior. Unfortunately I am not aware of the number of cores that were available during his test runs.

If I find some time I'll try to build the reproduction case on one of the vm's where I was able to reproduce the issue with a locally compiled binary and see whether the same behavior still occurs.

I can reproduce this problem on build: 0.2.1-700-g827a243
I am using Linux x86_64, with kernel: 4.2.0-34, and I have 4 cores with 8GB of memory.

With the default number of threads (5) the process slowly starts to leak and continues leaking until all the free memory is used and then starts to swap.

With --ponythreads 8 as mentioned above by @hakvroot the leak is greatly accelerated.
I haven't looked at the code yet to see why this is. Can someone explain?

@sparseinference how many physical cpus do you have in your machine 4 or 2?

@SeanTAllen  I have 1 physical CPU : Intel(R) Core(TM)2 Quad  CPU  Q8200  @ 2.33GHz

according to:  /proc/cpuinfo

I tested this just now, no matter what I do, this eventually segfaults.

I tried this after upgrading from LLVM 3.8 to LLVM 3.8.1 and get the same results.

@SeanTAllen any chance the segfault was cleared up by #1321?

nope. still segfaults.

when i compile this with a debug build of the compiler, i get a more interesting and familiar looking result:

```
Assertion failed: (index < POOL_COUNT), function ponyint_pool_free, file src/libponyrt/mem/pool.c, line 602.
[1]    69440 segmentation fault  ./issue-517
```

@SeanTAllen Could you get a stack trace for that?

interesting... 

```
(lldb) run
Process 70432 launched: '/Users/sean/Dropbox/Private/Code/pony-scratch/issue-517/issue-517' (x86_64)
Process 70432 stopped
* thread #2: tid = 0x428559, 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x0000000119128da8) + 20 at messageq.c:70, stop reason = EXC_BAD_ACCESS (code=1, address=0x8)
    frame #0: 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x0000000119128da8) + 20 at messageq.c:70
   67   pony_msg_t* ponyint_messageq_pop(messageq_t* q)
   68   {
   69     pony_msg_t* tail = q->tail;
-> 70     pony_msg_t* next = atomic_load_explicit(&tail->next, memory_order_acquire);
   71
   72     if(next != NULL)
   73     {
  thread #4: tid = 0x42855a, 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x0000000128ce6d08) + 20 at messageq.c:70, stop reason = EXC_BAD_ACCESS (code=1, address=0x8)
    frame #0: 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x0000000128ce6d08) + 20 at messageq.c:70
   67   pony_msg_t* ponyint_messageq_pop(messageq_t* q)
   68   {
   69     pony_msg_t* tail = q->tail;
-> 70     pony_msg_t* next = atomic_load_explicit(&tail->next, memory_order_acquire);
   71
   72     if(next != NULL)
   73     {
  thread #5: tid = 0x42855b, 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x00000001289f0048) + 20 at messageq.c:70, stop reason = EXC_BAD_ACCESS (code=1, address=0x8)
    frame #0: 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x00000001289f0048) + 20 at messageq.c:70
   67   pony_msg_t* ponyint_messageq_pop(messageq_t* q)
   68   {
   69     pony_msg_t* tail = q->tail;
-> 70     pony_msg_t* next = atomic_load_explicit(&tail->next, memory_order_acquire);
   71
   72     if(next != NULL)
   73     {
  thread #6: tid = 0x42855c, 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x000000013013c6e8) + 20 at messageq.c:70, stop reason = EXC_BAD_ACCESS (code=1, address=0x8)
    frame #0: 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x000000013013c6e8) + 20 at messageq.c:70
   67   pony_msg_t* ponyint_messageq_pop(messageq_t* q)
   68   {
   69     pony_msg_t* tail = q->tail;
-> 70     pony_msg_t* next = atomic_load_explicit(&tail->next, memory_order_acquire);
   71
   72     if(next != NULL)
   73     {
(lldb) bt
warning: could not load any Objective-C class information. This will significantly reduce the quality of type information available.
* thread #2: tid = 0x428559, 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x0000000119128da8) + 20 at messageq.c:70, stop reason = EXC_BAD_ACCESS (code=1, address=0x8)
  * frame #0: 0x00000001000050d4 issue-517`ponyint_messageq_pop(q=0x0000000119128da8) + 20 at messageq.c:70
    frame #1: 0x000000010000445c issue-517`ponyint_actor_run(ctx=0x00000001097ff848, actor=0x0000000119128da0, batch=100) + 252 at actor.c:155
    frame #2: 0x000000010000f99f issue-517`run(sched=0x00000001097ff800) + 175 at scheduler.c:267
    frame #3: 0x000000010000f799 issue-517`run_thread(arg=0x00000001097ff800) + 57 at scheduler.c:309
    frame #4: 0x00007fff9c9f499d libsystem_pthread.dylib`_pthread_body + 131
    frame #5: 0x00007fff9c9f491a libsystem_pthread.dylib`_pthread_start + 168
    frame #6: 0x00007fff9c9f2351 libsystem_pthread.dylib`thread_start + 13
```

@Praetonus - is it possible that our atomics aren't actually atomic on @SeanTAllen's platform?

OSX El Capitan 10.11.6
2.6 ghz Intel core i7

Its a fairly standard Macbook Pro so the not actually being atomic would be concerning.

No, that's not possible. Even if the code generation for the C atomics was bugged, which is unlikely, memory operations on x86 are atomic with acquire/release semantics by default.

It's been a little while since I seriously used C++ but in  the file "messageq.c" at line #70, shouldn't 
`atomic_load_explicit(&tail->next, memory_order_acquire)` 
use an atomic pointer?

In the definition of `messageq_t` : 

`typedef struct messageq_t`
`{`
`PONY_ATOMIC(pony_msg_t*) head;`
`pony_msg_t* tail;`
`} messageq_t;`

the **tail** member is not declared **PONY_ATOMIC**. 

That's true. but, tail->next is:

```
typedef struct pony_msg_t
{
  uint32_t index;
  uint32_t id;
  PONY_ATOMIC(struct pony_msg_t*) next;
} pony_msg_t;
```

Can anyone else test this and see if they get the same segfault issue?

This is what has me particularly concerned: 

`Assertion failed: (index < POOL_COUNT), function ponyint_pool_free, file src/libponyrt/mem/pool.c, line 602.`

odd, i can no longer trigger the (index < POOL_COUNT) with the latest code but I still get the segfault. here's my latest using `ponyc`:

```
Process 14505 launched: './issue-517' (x86_64)
Process 14505 stopped
* thread #2: tid = 0x493dd0, 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 82 at mpmcq.c:78, stop reason = EXC_BAD_ACCESS (code=1, address=0xfffffffa00000000)
    frame #0: 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 82 at mpmcq.c:78
   75
   76       // Get the next node rather than the tail. The tail is either a stub or has
   77       // already been consumed.
-> 78       next = atomic_load_explicit(&tail->next, memory_order_acquire);
   79
   80       // Bailout if we have no next node.
   81       if(next == NULL)
  thread #4: tid = 0x493dd1, 0x0000000100002c23 issue-517`ponyint_actor_run(ctx=0x00000001097ff988, actor=0x0000000121079840, batch=100) + 67 at actor.c:136, stop reason = EXC_BAD_ACCESS (code=1, address=0x108)
    frame #0: 0x0000000100002c23 issue-517`ponyint_actor_run(ctx=0x00000001097ff988, actor=0x0000000121079840, batch=100) + 67 at actor.c:136
   133    while(actor->continuation != NULL)
   134    {
   135      msg = actor->continuation;
-> 136      actor->continuation = atomic_load_explicit(&msg->next,
   137         memory_order_relaxed);
   138      bool ret = handle_message(ctx, actor, msg);
   139      ponyint_pool_free(msg->index, msg);
  thread #5: tid = 0x493dd2, 0x000000010000dc92 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 274 at mpmcq.c:91, stop reason = EXC_BAD_ACCESS (code=1, address=0xfffffffa00000008)
    frame #0: 0x000000010000dc92 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 274 at mpmcq.c:91
   88       memory_order_acq_rel, memory_order_relaxed));
   89
   90     // We'll return the data pointer from the next node.
-> 91     void* data = atomic_load_explicit(&next->data, memory_order_relaxed);
   92
   93     // Since we will be freeing the old tail, we need to be sure no other
   94     // consumer is still reading the old tail. To do this, we set the data
  thread #6: tid = 0x493dd3, 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 82 at mpmcq.c:78, stop reason = EXC_BAD_ACCESS (code=1, address=0xfffffffa00000000)
    frame #0: 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 82 at mpmcq.c:78
   75
   76       // Get the next node rather than the tail. The tail is either a stub or has
   77       // already been consumed.
-> 78       next = atomic_load_explicit(&tail->next, memory_order_acquire);
   79
   80       // Bailout if we have no next node.
   81       if(next == NULL)
(lldb) bt
warning: could not load any Objective-C class information. This will significantly reduce the quality of type information available.
* thread #2: tid = 0x493dd0, 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 82 at mpmcq.c:78, stop reason = EXC_BAD_ACCESS (code=1, address=0xfffffffa00000000)
  * frame #0: 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ffb80) + 82 at mpmcq.c:78
    frame #1: 0x000000010000e44c issue-517`pop(sched=0x00000001097ffa80) + 28 at scheduler.c:40
    frame #2: 0x000000010000e320 issue-517`pop_global(sched=0x00000001097ffa80) + 64 at scheduler.c:61
    frame #3: 0x000000010000e383 issue-517`steal(sched=0x00000001097ff800, prev=0x0000000000000000) + 83 at scheduler.c:220
    frame #4: 0x000000010000e1a1 issue-517`run(sched=0x00000001097ff800) + 49 at scheduler.c:256
    frame #5: 0x000000010000e019 issue-517`run_thread(arg=0x00000001097ff800) + 57 at scheduler.c:309
    frame #6: 0x00007fff9c9f499d libsystem_pthread.dylib`_pthread_body + 131
    frame #7: 0x00007fff9c9f491a libsystem_pthread.dylib`_pthread_start + 168
    frame #8: 0x00007fff9c9f2351 libsystem_pthread.dylib`thread_start + 13
```

@Praetonus look at thread 4. isn't the pony not supposed to end up in the `while(actor->continuation != NULL)` or did I misunderstand @sylvanc?

as of 616b075 this has the old non-segfaulting behavior.

as of 33caa7f we have both memory growth and segfaulting.

@Praetonus the segfaulting was introduced with 83bc2aa71ad7598275cfdffe858dbd6eabb68738

```
Process 31786 launched: './issue-517' (x86_64)
Process 31786 stopped
* thread #2: tid = 0x49f8a1, 0x000000010000dbc2 issue-517`ponyint_mpmcq_pop(q=0x0000000108fffcc0) + 82 at mpmcq.c:76, stop reason = EXC_BAD_ACCESS (code=1, address=0xfffffffa00000000)
    frame #0: 0x000000010000dbc2 issue-517`ponyint_mpmcq_pop(q=0x0000000108fffcc0) + 82 at mpmcq.c:76
   73
   74       // Get the next node rather than the tail. The tail is either a stub or has
   75       // already been consumed.
-> 76       next = atomic_load_explicit(&tail->next, memory_order_acquire);
   77
   78       // Bailout if we have no next node.
   79       if(next == NULL)
  thread #4: tid = 0x49f8a2, 0x000000010000dbc2 issue-517`ponyint_mpmcq_pop(q=0x0000000108fffcc0) + 82 at mpmcq.c:76, stop reason = EXC_BAD_ACCESS (code=1, address=0xfffffffa00000000)
    frame #0: 0x000000010000dbc2 issue-517`ponyint_mpmcq_pop(q=0x0000000108fffcc0) + 82 at mpmcq.c:76
   73
   74       // Get the next node rather than the tail. The tail is either a stub or has
   75       // already been consumed.
-> 76       next = atomic_load_explicit(&tail->next, memory_order_acquire);
   77
   78       // Bailout if we have no next node.
   79       if(next == NULL)
  thread #5: tid = 0x49f8a3, 0x0000000100002c13 issue-517`ponyint_actor_run(ctx=0x0000000108fffac8, actor=0x0000000118d828c0, batch=100) + 67 at actor.c:134, stop reason = EXC_BAD_ACCESS (code=1, address=0x108)
    frame #0: 0x0000000100002c13 issue-517`ponyint_actor_run(ctx=0x0000000108fffac8, actor=0x0000000118d828c0, batch=100) + 67 at actor.c:134
   131    while(actor->continuation != NULL)
   132    {
   133      msg = actor->continuation;
-> 134      actor->continuation = msg->next;
   135      bool ret = handle_message(ctx, actor, msg);
   136      ponyint_pool_free(msg->index, msg);
   137
  thread #6: tid = 0x49f8a4, 0x000000010000dc82 issue-517`ponyint_mpmcq_pop(q=0x0000000108fffcc0) + 274 at mpmcq.c:89, stop reason = EXC_BAD_ACCESS (code=1, address=0xfffffffa00000008)
    frame #0: 0x000000010000dc82 issue-517`ponyint_mpmcq_pop(q=0x0000000108fffcc0) + 274 at mpmcq.c:89
   86       memory_order_acq_rel, memory_order_acquire));
   87
   88     // We'll return the data pointer from the next node.
-> 89     void* data = atomic_load_explicit(&next->data, memory_order_acquire);
   90
   91     // Since we will be freeing the old tail, we need to be sure no other
   92     // consumer is still reading the old tail. To do this, we set the data
```

and this is the result on current head of master:

```
(lldb) run
Process 34246 launched: './issue-517' (x86_64)
Process 34246 stopped
* thread #2: tid = 0x4a0f22, 0x000000010000dcaa issue-517`ponyint_mpmcq_pop(q=0x00000001097ff900) + 298 at mpmcq.c:97, stop reason = EXC_BAD_ACCESS (code=2, address=0x100000008)
    frame #0: 0x000000010000dcaa issue-517`ponyint_mpmcq_pop(q=0x00000001097ff900) + 298 at mpmcq.c:97
   94     // consumer is still reading the old tail. To do this, we set the data
   95     // pointer of our new tail to NULL, and we wait until the data pointer of
   96     // the old tail is NULL.
-> 97     atomic_store_explicit(&next->data, NULL, memory_order_release);
   98
   99     while(atomic_load_explicit(&tail->data, memory_order_acquire) != NULL)
   100      ponyint_cpu_relax();
  thread #4: tid = 0x4a0f23, 0x0000000100003964 issue-517`ponyint_messageq_pop(q=0x00000001217bb608) + 20 at messageq.c:70, stop reason = EXC_BAD_ACCESS (code=1, address=0x8)
    frame #0: 0x0000000100003964 issue-517`ponyint_messageq_pop(q=0x00000001217bb608) + 20 at messageq.c:70
   67   pony_msg_t* ponyint_messageq_pop(messageq_t* q)
   68   {
   69     pony_msg_t* tail = q->tail;
-> 70     pony_msg_t* next = atomic_load_explicit(&tail->next, memory_order_acquire);
   71
   72     if(next != NULL)
   73     {
  thread #5: tid = 0x4a0f24, 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ff900) + 82 at mpmcq.c:78, stop reason = EXC_BAD_ACCESS (code=EXC_I386_GPFLT)
    frame #0: 0x000000010000dbd2 issue-517`ponyint_mpmcq_pop(q=0x00000001097ff900) + 82 at mpmcq.c:78
   75
   76       // Get the next node rather than the tail. The tail is either a stub or has
   77       // already been consumed.
-> 78       next = atomic_load_explicit(&tail->next, memory_order_acquire);
   79
   80       // Bailout if we have no next node.
   81       if(next == NULL)
  thread #6: tid = 0x4a0f25, 0x000000010000dc92 issue-517`ponyint_mpmcq_pop(q=0x00000001097ff900) + 274 at mpmcq.c:91, stop reason = EXC_BAD_ACCESS (code=EXC_I386_GPFLT)
    frame #0: 0x000000010000dc92 issue-517`ponyint_mpmcq_pop(q=0x00000001097ff900) + 274 at mpmcq.c:91
   88       memory_order_acq_rel, memory_order_relaxed));
   89
   90     // We'll return the data pointer from the next node.
-> 91     void* data = atomic_load_explicit(&next->data, memory_order_relaxed);
   92
   93     // Since we will be freeing the old tail, we need to be sure no other
   94     // consumer is still reading the old tail. To do this, we set the data
(lldb)
```

@sparseinference btw, i tried that change and didnt see an improvement. i figured ¯_(ツ)_/¯ can't hurt to try.

oth @sparseinference, @Praetonus is this code from messageq.c problematic with the changes in 83bc2aa71ad7598275cfdffe858dbd6eabb68738?

``` pony
bool ponyint_messageq_markempty(messageq_t* q)
{
  pony_msg_t* tail = q->tail;
  pony_msg_t* head = atomic_load_explicit(&q->head, memory_order_relaxed);

  if(((uintptr_t)head & 1) != 0)
    return true;

  if(head != tail)
    return false;

  head = (pony_msg_t*)((uintptr_t)head | 1);

  return atomic_compare_exchange_strong_explicit(&q->head, &tail, head,
    memory_order_release, memory_order_relaxed);
}
```

I'm not really sure how `atomic_compare_exchange_strong_explicit` works.

I'm not sure how it works either, even after reading: [this explanation](http://en.cppreference.com/w/c/atomic/atomic_compare_exchange).

I can also reproduce the segmentation fault, consistently somewhere in `ponyint_messageq_pop`. 

I'll try to debug it further.

I don't think the issue is in `messageq`. It looks like pointer values somehow get bitwise-shifted in `ponyint_mpmcq_pop`. That's really odd because I've made sure to handle that case in the bitwise operations for the ABA, and the segfault should happen all the time if the returned pointers are wrong.

@SeanTAllen @sparseinference Can you replace `ponyint_mpmcq_pop` with [this version](https://gist.github.com/Praetonus/924929e63bf8daba1159e3d99530114f) and see if the segfault still happens? You'll have to add `ATOMIC_TYPE(size_t) ticket` and `ATOMIC_TYPE(size_t) waiting_for` to `struct mpmcq_t` for it to work.

PS : The `atomic_compare_exchange_strong` in `ponyint_messageq_markempty` atomically replaces `q->head` by `head` if `q->head` and `tail` are bitwise-equal and replaces `tail` by `q->head` if they're not (which has no effect here since `tail` is local and the function returns immediately after that).

@Praetonus I assume you mean `PONY_ATOMIC(size_t) ticket` not `ATOMIC_TYPE(size_t) ticket` correct;

@Praetonus assuming the above is true, then both this and #647 ran to completion (and lots of memory usage) with the change to `ponyint_mpmcq_pop`

If you turn off work stealing, the memory growth goes away.

https://gist.github.com/SeanTAllen/41cb87b08d59538a01a8b7d39aab2e19

@Praetonus - I applied your changes (using PONY_ATOMIC for the new members of `struct mpmcq_t`).
I used the program from @hakvroot to test, compiled with a debug build of ponyc, and it ran without errors or memory leak.

I also ran the test program with `valgrind --tool=drd`  and no errors were reported.

However, if I pass `--ponythreads 2` to the test program under valgrind, it reports many conflicting loads and and stores.
I'm unsure if that's a valid parameter to use. When I increase it to 3 there are no conflicts reported.

For example:

> ==8779== Conflicting load by thread 4 at 0x0e15eae8 size 8
> ==8779==    at 0x40D4CE: ponyint_mpmcq_pop (mpmcq.c:136)
> ==8779==    by 0x40C454: pop (scheduler.c:40)
> ==8779==    by 0x40C4B8: pop_global (scheduler.c:61)
> ==8779==    by 0x40C8F4: steal (scheduler.c:220)
> ==8779==    by 0x40CA73: run (scheduler.c:281)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting store by thread 4 at 0x0e15eae8 size 8
> ==8779==    at 0x40D4FC: ponyint_mpmcq_pop (mpmcq.c:142)
> ==8779==    by 0x40C454: pop (scheduler.c:40)
> ==8779==    by 0x40C4B8: pop_global (scheduler.c:61)
> ==8779==    by 0x40C8F4: steal (scheduler.c:220)
> ==8779==    by 0x40CA73: run (scheduler.c:281)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)

`mpmcq.c:136` and `mpmcq.c:142` are in your modified `void* ponyint_mpmcq_pop(mpmcq_t* q)` at:

`
// We'll return the data pointer from the next node.  
void* data = atomic_load_explicit(&next->data, memory_order_relaxed);  
`

and

`
// Since we will be freeing the old tail, we need to be sure no other
// consumer is still reading the old tail. To do this, we set the data
// pointer of our new tail to NULL, and we wait until the data pointer of  
// the old tail is NULL.`
`atomic_store_explicit(&next->data, NULL, memory_order_release);`

Some other reported conflicts are:

> ==8779== Conflicting store by thread 4 at 0x0e15ea00 size 8
> ==8779==    at 0x40B3DF: ponyint_pool_free (pool.c:611)
> ==8779==    by 0x40E8D3: delta_free (delta.c:22)
> ==8779==    by 0x409D26: ponyint_hashmap_destroy (hash.c:111)
> ==8779==    by 0x40E95F: ponyint_deltamap_destroy (delta.c:35)
> ==8779==    by 0x40EB87: ponyint_deltamap_free (delta.c:68)
> ==8779==    by 0x40F49F: apply_delta (cycle.c:239)
> ==8779==    by 0x40F510: mark_grey (cycle.c:249)
> ==8779==    by 0x40F621: scan_grey (cycle.c:279)
> ==8779==    by 0x40FCAE: detect (cycle.c:443)
> ==8779==    by 0x40FF05: deferred (cycle.c:488)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15dd50 size 8
> ==8779==    at 0x40A074: ponyint_hashmap_next (hash.c:197)
> ==8779==    by 0x40F035: ponyint_viewmap_next (cycle.c:110)
> ==8779==    by 0x40FF2A: deferred (cycle.c:482)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779==    by 0x40840E: handle_message (actor.c:97)
> ==8779==    by 0x4085C8: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15dd48 size 8
> ==8779==    at 0x409FBD: ponyint_hashmap_removeindex (hash.c:174)
> ==8779==    by 0x40EFF6: ponyint_viewmap_removeindex (cycle.c:110)
> ==8779==    by 0x40FEE6: deferred (cycle.c:485)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779==    by 0x40840E: handle_message (actor.c:97)
> ==8779==    by 0x4085C8: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15e830 size 8
> ==8779==    at 0x40A074: ponyint_hashmap_next (hash.c:197)
> ==8779==    by 0x40EA98: ponyint_deltamap_next (delta.c:35)
> ==8779==    by 0x40F484: apply_delta (cycle.c:199)
> ==8779==    by 0x40F510: mark_grey (cycle.c:249)
> ==8779==    by 0x40F621: scan_grey (cycle.c:279)
> ==8779==    by 0x40FCAE: detect (cycle.c:443)
> ==8779==    by 0x40FF05: deferred (cycle.c:488)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779==    by 0x40840E: handle_message (actor.c:97)
> ==8779==    by 0x4085C8: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15ea00 size 8
> ==8779==    at 0x40E8E3: ponyint_delta_actor (delta.c:27)
> ==8779==    by 0x40F375: apply_delta (cycle.c:202)
> ==8779==    by 0x40F510: mark_grey (cycle.c:249)
> ==8779==    by 0x40F621: scan_grey (cycle.c:279)
> ==8779==    by 0x40FCAE: detect (cycle.c:443)
> ==8779==    by 0x40FF05: deferred (cycle.c:488)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779==    by 0x40840E: handle_message (actor.c:97)
> ==8779==    by 0x4085C8: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15ea08 size 8
> ==8779==    at 0x40E8F4: ponyint_delta_rc (delta.c:32)
> ==8779==    by 0x40F385: apply_delta (cycle.c:203)
> ==8779==    by 0x40F510: mark_grey (cycle.c:249)
> ==8779==    by 0x40F621: scan_grey (cycle.c:279)
> ==8779==    by 0x40FCAE: detect (cycle.c:443)
> ==8779==    by 0x40FF05: deferred (cycle.c:488)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779==    by 0x40840E: handle_message (actor.c:97)
> ==8779==    by 0x4085C8: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15dd28 size 8
> ==8779==    at 0x409DC3: ponyint_hashmap_get (hash.c:125)
> ==8779==    by 0x40EF3D: ponyint_viewmap_get (cycle.c:110)
> ==8779==    by 0x40F28D: get_view (cycle.c:172)
> ==8779==    by 0x40F3A7: apply_delta (cycle.c:207)
> ==8779==    by 0x40F510: mark_grey (cycle.c:249)
> ==8779==    by 0x40F621: scan_grey (cycle.c:279)
> ==8779==    by 0x40FCAE: detect (cycle.c:443)
> ==8779==    by 0x40FF05: deferred (cycle.c:488)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779==    by 0x40840E: handle_message (actor.c:97)
> ==8779==    by 0x4085C8: ponyint_actor_run (actor.c:157)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15d8c0 size 8
> ==8779==    at 0x40EE1A: view_cmp (cycle.c:87)
> ==8779==    by 0x409A6E: search (hash.c:39)
> ==8779==    by 0x409DF0: ponyint_hashmap_get (hash.c:129)
> ==8779==    by 0x40EF3D: ponyint_viewmap_get (cycle.c:110)
> ==8779==    by 0x40F28D: get_view (cycle.c:172)
> ==8779==    by 0x40F3A7: apply_delta (cycle.c:207)
> ==8779==    by 0x40F510: mark_grey (cycle.c:249)
> ==8779==    by 0x40F621: scan_grey (cycle.c:279)
> ==8779==    by 0x40FCAE: detect (cycle.c:443)
> ==8779==    by 0x40FF05: deferred (cycle.c:488)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)
> 
> ==8779== Conflicting load by thread 4 at 0x0e15dd30 size 8
> ==8779==    at 0x409E3A: ponyint_hashmap_put (hash.c:135)
> ==8779==    by 0x40EF91: ponyint_viewmap_put (cycle.c:110)
> ==8779==    by 0x40F2F2: get_view (cycle.c:181)
> ==8779==    by 0x40F3A7: apply_delta (cycle.c:207)
> ==8779==    by 0x40F510: mark_grey (cycle.c:249)
> ==8779==    by 0x40F621: scan_grey (cycle.c:279)
> ==8779==    by 0x40FCAE: detect (cycle.c:443)
> ==8779==    by 0x40FF05: deferred (cycle.c:488)
> ==8779==    by 0x410395: block (cycle.c:610)
> ==8779==    by 0x410B0E: cycle_dispatch (cycle.c:792)
> ==8779==    by 0x40840E: handle_message (actor.c:97)
> ==8779==    by 0x4085C8: ponyint_actor_run (actor.c:157)
> ==8779== Allocation context: unknown.
> ==8779== Other segment start (thread 3)
> ==8779==    at 0x5895081: clone (clone.S:80)
> ==8779==    by 0x4E5263F: ??? (allocatestack.c:289)
> ==8779==    by 0x1715F6FF: ???
> ==8779== Other segment end (thread 3)
> ==8779==    at 0x4085B2: ponyint_actor_run (actor.c:157)
> ==8779==    by 0x40CA08: run (scheduler.c:267)
> ==8779==    by 0x40CAFA: run_thread (scheduler.c:309)
> ==8779==    by 0x4C33483: ??? (in /usr/lib/valgrind/vgpreload_drd-amd64-linux.so)
> ==8779==    by 0x4E52709: start_thread (pthread_create.c:333)
> ==8779==    by 0x58950AE: clone (clone.S:105)

@sparseinference Valgrind doesn't know about atomic operations so it sees everything not protected by a lock as a data race. I believe all of these are false positives but unfortunately there is no way to confirm this with tools in the current state of the runtime. IIRC there are ways to make Valgrind aware of operations with acquire/release semantics, maybe we can add that to the Valgrind build of the runtime.

If that implementation of `mpmcq_pop` solves the various segfaults, we should consider integrating it in the runtime instead of going back to the old implementation with a full-word ABA tag. Some microbenchmarks show a slight performance win over the current implementation with no contention and a slight loss on the average time to pop an actor with high contention (8 threads continuously popping actors). However, since high contention basically never happens on that in the actual runtime, I think this is a good tradeoff.

@Praetonus i'm not sure why you think that high contention scenario would never happen in the runtime. perhaps i don't understand what you mean by high contention from that description. can you elaborate?

Contention on a scheduler queue can only happen in the work-stealing scenario, but there are heuristics ensuring that as few threads as possible will try to steal from the same scheduler. We can regularly have ~2 threads popping from the same queue at the same time but high contention would require having multiple threads starving for work and trying to steal from the same scheduler, which is unlikely.

The same CAS loop is also used in the pool allocator, but high contention is also unlikely in that case. That loop is only encountered when a given thread has 1 MiB of free memory on a slab (different slabs can never interact with each other) so even the 2 threads scenario contention is unlikely.

@Praetonus can you think of a reason why the conflicts reported by `--tool=drd` disappear with 
`--ponythreads` > 2 ?

@Praetonus i've talked a bit about this w/ sylvan. the memory growth here and #647 happens on my machine when work stealing happens. i can fairly reasonably reproduce memory growth by causing work stealing to happen. any thoughts on why that might be given that you've been in a related part of the code base recently.

@sparseinference when you ran without memory growth, how many ponythreads did you use?

what os are you using?
what llvm version?
debug version of the compiler? releasE?

any details you can give would really help me.

@sparseinference I'm not sure. Maybe the work is more evenly distributed with more than 2 threads, which reduces the probability of multiple threads popping from the same queue at the same time.

@SeanTAllen I don't see anything.

@Praetonus i'll keep looking.

re: the patch. do you want to PR that or shall I? I have it in place already and can easily commit and open. if i do it though, i could use a little help with what to put in the CHANGELOG beyond "fix segfault bug introduced by 83bc2aa"

@SeanTAllen  
- I'm using Kubuntu 16.10
- clang-3.9
- 0.5.0-c5ae21e [debug](llvm 3.9.0) (cc (Ubuntu 6.2.0-5ubuntu12) 6.2.0 20161005)

I ran the test with `--ponythreads` 2 ... 5,  and   `--ponythreads 50`

Interestingly, at `--ponythreads 50` some of the threads are created but never scheduled - I assume this is what's happening because their CPU time is zero while the active threads have an equal share of the CPU.

My computer has an i7-5930K CPU @ 3.50GHz - 6 hyperthreading cores.

Thanks @sparseinference.

@SeanTAllen The code must be adapted to the pool allocator so I'll do it if you're not sure.

@Praetonus i'm not sure how it would be adapted, so have at it.

i found a "fix" for this. pretty sure I understand what is going on. need to discuss a proper solution with @sylvanc. FYI, it is the same issue as #647.

This and #647 are the same problem.

In general what happens is, with a higher number of schedulers, when a scheduler goes to steal work or otherwise get work to do, it finds none available. This causes it to send a block message to the cycle detector (the message causes a memory allocation). They do this every time they try to run, which results in a ton of block messages being sent. Combine this with our intentionally not running the cycle detector often and _memory explosion_.

The short term fix for this is to run with --ponynoblock. Running with --ponynoblock means your application isn't going to exit. Ever. But, it gets you around this problem. (Or, you can run with fewer ponythreads).

I had an idea for how to handle cycle detection that wouldn't cause this problem. After talking to @sylvanc, it turns out he had already been entertaining a similar and more fully fleshed out idea. We need to prove it will work, but the general idea is. 

The cycle detector observes the state of the world and if it finds what it believes to be a cycle, it can send a message to the members of that cycle saying "this is my view of the world, I believe you are a cycle". Those actors can contradict the cycle detector and let it know its view is incorrect or they agree that they are in a cycle and exit. By following a system of this general sort, no messages are sent to the cycle detector without it first sending a message. There's a lot of details that would need to be fleshed out and @sylvanc's idea is farther along than mine, but this explanation should give you a vague handwave idea of the long term fix.

I've created a backpressure branch that address this by applying the in progress backpressure system to the cycle detector: `backpressure-all-the-things`
it appears that the cycle detector is a bit of a red herring. its not the real issue. this is the same bug as #647 and #2317.

the problem is with the memory allocator. block messages if changed to be sent as the smaller size pony_msgp_t results in no memory growth. i believe because unblock messages also are the same nice and the allocator is more like to find the space required.

in #2317, @slfritchie points to the issue. i did some testing where i:

- turned off scheduler block/unblock messages to cut down on noise.
- discarded all block/unblock/ack actor messages upon receipt so we could rule out a bug with memory not being freed in any of the view map manipulations.
- switch `ponyint_cycle_block` to be:

```pony
void ponyint_cycle_block(pony_ctx_t* ctx, pony_actor_t* actor, gc_t* gc)
{
  pony_assert(ctx->current == actor);
  pony_assert(&actor->gc == gc);

  pony_msgp_t* m = (pony_msgp_t*)pony_alloc_msg(
    POOL_INDEX(sizeof(pony_msgp_t)), ACTORMSG_BLOCK);

  pony_sendv(ctx, cycle_detector, &m->msg, &m->msg, false);
}
```

this results in what is usually very stable memory usage after a period of time, with rare occassional jumps. i'm fairly sure that the allocator needs to be addressed. i can see that the cycle detector is not getting overwhelmed with messages. i believe the cycle detector play a part in backpressure that seemed to help address this was merely changing the pattern of block message allocations thereby changing the memory usage pattern.
I found an interesting possible "fix" for this. The real fix is we need a coalescing allocator. However, run away memory can be contained by making all block messages allocate the same amount of memory. 

This results in less fragmentation in memory and less overall memory being allocated then when messages are of a different size. To do this, we would make the block, unblock and ack messages all the same size. it "wastes" more memory unblock and ack messages but tamps down on the run away memory growth edge case.

even if its not a perfect solution. i think we should make it part of a larger solution given how they are so often paired together (block/unblock messages).


PR https://github.com/ponylang/ponyc/pull/2355 helps address this issue and it unrelated to the aforementioned allocator twiddling.
The memory situation has improved quite a lot with 0.21.0 with this but its still in need of improvement. Before it was a very rapid OOM, now memory grows but it takes quite a bit longer to get there.

However, #2386 solves the problem. Memory usage with --ponythreads=16 is a stable 2976 because the number of actual threads in usage is really low (1) so all the block/unblock etc messages is vastly reduced.

I still think that we should be looking at the "block, unblock and ack" messages and how they interact with the allocator but.... I would say that once #2386 is merged, we can close this.
Closed by #2386 